Attribute VB_Name = "modCrypt"
Public Function WS_Decrypt(CypherText As String)


On Error GoTo ErrorH
Dim caracter As String
Dim sal As String
Dim DeHexed As Integer
Dim salmod As Integer
Dim salaug As Integer
Dim passw As String
frmWs_Encrypt.Text1(3) = ""
Debug.Print                   'This function generates a debug report of the process. WS_Encrypt doesn't.
Debug.Print "---Decrypt---"
Debug.Print Now2
    
    passw = Mid(CypherText, 33, Len(CypherText) - 32) 'First character of passw is actually a placeholder, because of the way the next DO/Loop works
 
    I = 1
    Do While I < Len(passw) / 2         'divided by two because the hex is in two didgit format
        caracter = Mid(passw, I * 2, 2) 'I translated this from a javascript written in spanish.
        sal = Mid(CypherText, 1 + I, 1) 'sal = salt
        DeHexed = modMath.C_HexInt(caracter)  'modMath.C_HexInt turns hex string to integers
        DeHexedMinPos = DeHexed - I         'These four line are the actual cipher
        salaug = 47 + modMath.C_HexInt(sal)
        salmod = salaug Mod 57              'Mod is an operator. Check the help file for more info.
        claro = DeHexedMinPos - salmod
        WS_Decrypt = WS_Decrypt & Chr(claro)
        
        Debug.Print "For Letter '" & Chr(claro) & "' at pos " & I
        Debug.Print "   Hex caracter = "; caracter & "; Hex Salt: "; sal & "; DeHex caracter = " & DeHexed & "; DeHex caracter - Pos = "; DeHexedMinPos
        Debug.Print "   salaug 47 = " & salaug & "; Salaug Mod 57 = " & salmod & "; MinPos - (Salaug Mod 57) = " & claro & "; Current Decrypted Str = " & WS_Decrypt
        I = I + 1
    Loop

Exit Function
ErrorH:
frmWs_Encrypt.Text1(3) = "Getting Error " & Err.Number & ":" & Err.Description 'You might want to take this out for your program.

End Function

Public Function WS_Encrypt(PlainText)
On Error GoTo ErrorH

Dim iSalt(32) As Integer
Dim sSalt(32) As String
Dim sLetterHex(32) As String
frmWs_Encrypt.Text1(3) = ""
    
    Randomize Timer

    For I = 1 To 32             'Generate 32 salt values in hex and int. More then you will usually need.
        iRand = Int(Rnd * 16)
        sHex = Hex(iRand)
        iSalt(I) = iRand
        sSalt(I) = sHex
    Next I
    
    For I = 1 To Len(PlainText)     'This loop is the cipher that encrypts each letter of plaintext into ciphertext using the random salt value and letter position.
        iLetter = Asc(Mid(PlainText, I, 1))
        SaltPlus = iSalt(I) + 47
        SaltPlus = SaltPlus Mod 57
        iLetter = iLetter + SaltPlus
        iLetter = iLetter + I
        sLetterHex(I) = Hex(iLetter)
    Next I
    
    sEncrypted = "V"                'V is always the first character. Probably has to do with the name of the cypher.
    
    For I = 1 To Len(PlainText)
        Debug.Print "Salt Val: " & iSalt(I) & " SaltHex: " & sHex
        sEncrypted = sEncrypted & sSalt(I)  'Append salt for each letter
    Next I
    
    numX = 32 - (Len(sEncrypted) - 1)
    
    For I = 1 To numX
        sEncrypted = sEncrypted & "X"       'Append placeholders
    Next I
    
    Debug.Print "NumX = " & I
    

    
    For I = 1 To 32
        sEncrypted = sEncrypted & sLetterHex(I) 'Append double didgit hex. This is the ascii value of the encrypted password.
    Next I
    
    WS_Encrypt = sEncrypted                     'Return

Exit Function
ErrorH:
frmWs_Encrypt.Text1(3) = "Getting Error " & Err.Number & ":" & Err.Description 'You might want to take this out for your program.

End Function

